require "defines"

local guiOpen = false

game.onevent(defines.events.ontick, function(event) OnTick(event) end)

local oldStack = nil
local totalCount = 0
function OnTick(event)
	for _, player in pairs(game.players) do
		CheckStack(player)
	end
end

function CheckStack(player)
	if player.cursorstack then
		OpenGUI(player)
		if player.cursorstack == oldStack then
			return
		else
			if oldStack and player.cursorstack.name == oldStack.name then			-- Still holding the same item.
				if player.cursorstack.count == oldStack.count - 1 then	-- Placed one.
					totalCount = totalCount - 1
				else
					CalculateTotal(player, player.cursorstack)
				end
			else
				CalculateTotal(player, player.cursorstack)
			end
			oldStack = player.cursorstack
		end
		SetGUIText(player, totalCount)
	else
		CloseGUI(player)
	end
end

function CalculateTotal(player, stack)
	totalCount = stack.count
	local inventory = player.getinventory(defines.inventory.playerquickbar)
	totalCount = totalCount + inventory.getitemcount(stack.name)
	inventory = player.getinventory(defines.inventory.playermain)
	totalCount = totalCount + inventory.getitemcount(stack.name)
end

function SetGUIText(player, text)
	if player.gui.center.itemcount then
		player.gui.center.itemcount.caption = text
	end
end
function OpenGUI(player)
	if not player.gui.center.itemcount then
		player.gui.center.add{type="label", name="itemcount", caption="100000", direction = "vertical"}
	end
end
function CloseGUI(player)
	if player.gui.center.itemcount then
		player.gui.center.itemcount.destroy()
	end
end